"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = addCreationStack;
function addCreationStack(fn, what) {
  var createdAt = new Error(what + ' created at:');
  return Object.assign(function withCause() {
    try {
      return fn.apply(void 0, arguments);
    } catch (error) {
      if (!error.creationStack) error.creationStack = function () {
        return createdAt.stack;
      };
      throw error;
    }
  }, fn);
}
module.exports = exports.default;