"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = prefixReducer;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _lodash = require("lodash");
var _createReducer = _interopRequireDefault(require("./createReducer.js"));
var _addCreationStack = _interopRequireDefault(require("./addCreationStack.js"));
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function prefixReducer(prefix) {
  return function (reducer) {
    if (reducer.actionHandlers instanceof Object) {
      return (0, _createReducer["default"])(reducer.initialState, (0, _lodash.mapKeys)(reducer.actionHandlers, function (handler, key) {
        return prefix + key;
      }));
    }
    var result = function result(state, action) {
      return typeof action.type === 'string' && action.type.startsWith(prefix) ? reducer(state, _objectSpread(_objectSpread({}, action), {}, {
        type: action.type.substring(prefix.length)
      })) : state;
    };
    if (process.env.NODE_ENV !== 'production') result = (0, _addCreationStack["default"])(result, 'reducer');
    return result;
  };
}
module.exports = exports.default;